package ants.controller;

import ants.model.Board;
import java.io.*;

public class FileHandler {

    private static final int WIDTH = 30;
    private static final int HEIGHT = 20;
        
    public Board loadBoard() {

        Board b = null;
        try {
            FileInputStream fileIn = new FileInputStream("/tmp/board.ser");
            ObjectInputStream in = new ObjectInputStream(fileIn);
            try {
                b = (Board) in.readObject();
            } catch (ClassNotFoundException ex) {
                System.out.println("/tmp/board.ser doesn't contain board");
                b = new Board(WIDTH, HEIGHT);
            }
            in.close();
            fileIn.close();
            System.out.println("Serialized data loaded from /tmp/board.ser");
            b.setFlagLoaded();
        } catch (IOException ex) {
            System.out.println("No data in /tmp/board.ser. Generating new map.");
            b = new Board(WIDTH, HEIGHT);
        }
        return b;
    }

    public boolean saveBoard(Board b) {
        try {
            FileOutputStream fileOut = new FileOutputStream("/tmp/board.ser");
            ObjectOutputStream out = new ObjectOutputStream(fileOut);
            out.writeObject(b);
            out.close();
            fileOut.close();
            System.out.println("Serialized data saved in /tmp/board.ser");
            return true;
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        return false;
    }
}
