package ants.gui;

import ants.controller.Controller;
import ants.model.Board;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.*;
import static javax.swing.JFrame.EXIT_ON_CLOSE;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class AntGUI extends JFrame implements ChangeListener {

    public Controller ctrl;

    private JLabel lbl_1;
    private JLabel lbl_2;
    private AntPanel panel;
    private JPanel controls;
    private JCheckBox cb_sync, cb_pick, cb_01;
    private JSpinner sp_work, sp_dummy, sp3;

    public AntGUI(Board board) {
        super();
        setSize(800, 600);
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        lbl_1 = new JLabel("Label");
        add(lbl_1, BorderLayout.NORTH);

        lbl_2 = new JLabel("Label");
        add(lbl_2, BorderLayout.SOUTH);

        controls = new JPanel(new GridLayout(10, 1));
        cb_sync = new JCheckBox("Synchronize");
        cb_pick = new JCheckBox("Pick ant first");
        cb_pick.setSelected(true);
        cb_01 = new JCheckBox("Allow only 0-1");
        cb_01.setSelected(true);
        controls.add(cb_sync);
        controls.add(cb_pick);
        controls.add(cb_01);
        controls.add(new JLabel("Worker delay [ms]"));
        controls.add(sp_work = new JSpinner(new SpinnerNumberModel(10, null, null, 1)));
        controls.add(new JLabel("Dummy operations"));
        controls.add(sp_dummy = new JSpinner(new SpinnerNumberModel()));
        cb_sync.addChangeListener(this);
        cb_pick.addChangeListener(this);
        cb_01.addChangeListener(this);
        sp_work.addChangeListener(this);
        sp_dummy.addChangeListener(this);

        add(controls, BorderLayout.EAST);

        panel = new AntPanel(board);
        add(panel, BorderLayout.CENTER);
        panel.setFocusable(true);
    }

    public void setLabelText(String string) {
        lbl_1.setText(string);
    }

    public void setLabel2Text(String string) {
        lbl_2.setText(string);
    }

    @Override
    public void stateChanged(ChangeEvent e) {
        ctrl.guiStateChanged(cb_sync.isSelected(), cb_pick.isSelected(), cb_01.isSelected(), (int) sp_work.getValue(), (int) sp_dummy.getValue());
    }

}
